;Program(s) contributed by Wendell Day
;Usage to explode blocks with attributes converting visible attributes
;into text


(defun c:attdeftotxt (/ en e x)
  (setq en (entget (car (while (not en) (setq en (entsel)))))
        e  '((0 . "TEXT"))
  )
  (if (= (read (cdr (assco 0 en))) 'ATTDEF)
     (progn
      (foreach x '(8 10 40 1 50 41 51 7 71 72 11 210 73)
         (setq e (append e (list (assoc x en))))
      )
      (entmake e)
      )
      (prompt "\nNot an attribute definition")
  ) 
  (prin1)
)
(defun c:explodeattrib (/ en e x)
  (setq en (entget (car (while (not en) (setq en (entsel)))))
        en1 en
  )
  (if (= (read (cdr (assoc 0 en))) 'INSERT)
    (progn 
     (while (= (read  (cdr (assoc 0 (setq en (entget (entnext (dxf -1 en))))))) 'ATTRIB)
      (setq e  '((0 . "TEXT"))) 
      (foreach x '(8 10 40 1 50 41 51 7 71 72 11 210 73)
         (if (assoc x en) (setq e (append e (list (assoc x en)))))
      );foreach
      (setq e (if (=  (cdr (assoc  1 e)) "") (subst (cons 1 (if (=  (cdr (assoc  2 en)) "") "No entry"  (cdr (assoc  3 en)))) (assoc 1 e) e) e))
      (entmake e)
     );while
     (command "explode"  (cdr (assoc  -1 en1)) "")
     (setq ssp (ssget "P")
           ssa (ssget "X" '((0 . "ATTDEF")))
     );setq
     (for 'x 0 (- (sslength ssa) 2) 1
       '(if (ssmemb (ssname ssa x) ssp) (entdel (ssname ssa x)))
     )
     (redraw)
    );progn
    (prompt "\nNot an block")
  )
  (prin1)
)
;* evaluates inclusive of maximum value
(defun FOR (symx initx endx stepx doprog / #xfor)
  (set '#xfor symx)
  (set #xfor  (- initx stepx))
  (while (<= (eval #xfor) endx)
     (set #xfor (+ (eval #xfor) stepx))
     (eval doprog)
) )
(c:explodeattrib)